
# This test looks at dcmp and beq/blt to see if two doubles
# are equal. It also uses icopy and iprint.
# The only way to really test any of the cmp instructions
# is to use a branch instruction afterwards, so unfortunately
# we have to test both these instructions here.
# Ideally we could just test the instruction we're interested in,
# but we can't do that in cases like these.

DOUBLE

d1:	0.577
d2:	0.577
d3:	1.5

CODE

	icopy	d1, r1
	icopy	d2, r2
	icopy	d3, r3

	dcmp	[r1], [r2]
	beq	yes1		# should branch

	iprint	7
	halt
yes1:
	dcmp	[r2], [r3]
	blt	yes2		# should branch

	iprint	8
	halt
yes2:
	dcmp	[r3], [r1]
	blt	no		# should not branch

	iprint	1		# correct answer
	halt

no:
	iprint	9
	halt

