
# Test if the array comparison functions work.

CODE

	icopy	0, r0
	icopy	1, r1
	icopy	2, r2
	icopy	3, r3

	anew	[r0]		# r0->[]
	ainsert	0, 7, [r0]	# r0->[7]
	ainsert 0, 5, [r0]	# r0->[5]
	ainsert 1, 3, [r0]	# r0->[5,3]
	ainsert 2, 2, [r0]	# r0->[5,3,2]

	anew	[r1]		# r1->[]
	ainsert 0, 3, [r1]	# r1->[3]
	ainsert 1, 3, [r1]	# r1->[3,3]
	ainsert 0, 5, [r1]	# r1->[5]
	ainsert 2, 2, [r1]	# r1->[5,3,2]

	acmp	[r0], [r1]	# r0 == r1
	blt	fail1		# just in case flags are set wrong
	bgt	fail1		# just in case flags are set wrong
	bne	fail1		# just in case flags are set wrong
	beq	yes1
fail1:
	iprint	4		# wrong answer
	bra	test2
yes1:
	iprint	0		# correct answer

test2:
	ainsert	2, 1, [r1]	# r1->[5,3,1]

	acmp	[r0], [r1]	# r0 > r1
	beq	fail2		# should not happen
	blt	fail2		# should not happen
	bgt	yes2
fail2:
	iprint	6		# wrong answer
	bra	test3
yes2:
	iprint	1		# correct answer

test3:
	ainsert	2, 2, [r1]	# r1->[5,3,2] == r0
	ainsert	3, 3, [r1]	# r1->[5,3,2,3]

	acmp	[r0], [r1]	# r0 < r1
	beq	fail3		# should not happen
	bgt	fail3		# should not happen
	blt	yes3
fail3:
	iprint	8		# wrong answer
	bra	end
yes3:
	iprint	-1		# correct answer

end:
	halt

