
# Test if the array comparison functions work.
# Check that Integers and Doubles are compared with each other

INT

int1:	7

DOUBLE

dbl1:	6.9
dbl2:	7.1

CODE

	icopy	10, r0
	icopy	11, r1

	icopy	int1, r7	# r7->7
	icopy	dbl1, r8	# r8->6.9
	icopy	dbl2, r9	# r9->7.1

	anew	[r0]		# r0->[]
	ainsert	0, [r7], [r0]	# r0->[7]
	ainsert	1, [r7], [r0]	# r0->[7,7]

	anew	[r1]		# r1->[]
	ainsert	0, [r7], [r1]	# r1->[7]
	ainsert 1, [r8], [r1]	# r1->[7,6.9]

	acmp	[r0], [r1]	# r0 > r1 since [7,7] > [7,6.9]
	blt	fail1		# just in case flags are set wrong
	beq	fail1		# just in case flags are set wrong
	bgt	yes1
fail1:
	iprint	4		# wrong answer
	bra	test2
yes1:
	iprint	1		# correct answer

test2:
	ainsert	1, [r9], [r1]	# r1->[7,7.1]

	acmp	[r0], [r1]	# r0 < r1 since [7,7] < [7,7.1]
	beq	fail2		# should not happen
	bgt	fail2		# should not happen
	blt	yes2
fail2:
	iprint	6		# wrong answer
	bra	test3
yes2:
	iprint	-1		# correct answer

test3:
	ainsert	1, [r9], [r0]	# r0->[7,7.1] == r1

	acmp	[r0], [r1]	# r0 == r1
	blt	fail3		# should not happen
	bgt	fail3		# should not happen
	beq	yes3
fail3:
	iprint	8		# wrong answer
	bra	end
yes3:
	iprint	0		# correct answer

end:
	halt

