#  This program tests the speed of a virtual machine's real number
#  operations, by repeatedly doing several operations in a loop.
#  The number of iterations is controlled by an integer
#  variable read in from stdin. Change this number to a million or
#  more, if you want a good speed test.
#  Use the unix 'time' command to see how long your VM takes:
#    time avm intspeed.avm < intspeed.in

DOUBLE

d1:	2.0
d2:	1.1
d3:	-6.6
d4:	4.5

STRING

report:	" was the result\n"

CODE

	iread	r0			# load number of repetitions
	icopy	sp, fp			# set frame pointer to top of stack
	ipush	r0			# store repeat on stack
	icopy	d1, r1
	icopy	d2, r2
	icopy	d3, r3
	icopy	d4, r4

dblspeed:
	# loop r0 times
	inew	r1			# initialise r1 = 0
loop:
	icmp	r1, r0
	bge	end

	ddiv	[r2], [r1], [r1]	# [r1] = [r1] / [r2]
	dmul	[r4], [r1], [r1]	# [r1] = [r1] * [r4]
	dadd	[r3], [r1], [r1]	# [r1] = [r1] + [r3]
	dabs	[r1], [r1]		# [r1] = abs([r1])
	dtoi	[r1], r5		# r5 = int([r1])
	itod	r5, [r1]		# [r1] = real(r5)

	isub	1, r0, r0		# step counter down by 1
	bra	loop
end:
	dprint	[r1]
	icopy	report, r5
	sprint	[r5]
	halt

	# end of dblspeed

