#  This program tests the speed of a virtual machine's integer
#  operations, by repeatedly doing a number of operations in a
#  loop. The number of iterations is controlled by an integer
#  variable read in from stdin. Change this number to a million or
#  more, if you want a good speed test.
#  Use the unix 'time' command to see how long your VM takes:
#    time avm intspeed.avm < intspeed.in

STRING

report:	" was the result\n"

CODE

	iread	r0			# load number of repetitions
	icopy	sp, fp			# set frame pointer to top of stack
	ipush	r0			# store repeat on stack
	icopy	7, r4			# r4 = 7

intspeed:
	# loop r0 times
	inew	r1			# initialise r1 = 0
loop:
	icmp	r1, r0
	bge	end

	idiv	2, r4, r4		# r4 = r4 / 2
	imul	r4, 15, r4		# r4 = 15 * r4
	iadd	[fp], r4, r4		# r4 = r4 + repeat
	imod	11, r4, r4		# r4 = r4 % 11

	isub	1, r0, r0		# step counter down by 1
	bra	loop
end:
	iprint	r4
	icopy	report, r5
	sprint	[r5]
	# end of intspeed

	# note there is no need to finish with a halt instruction
	# since the VM adds one automatically after reading in
	# the program

