#  A program to demonstrate function calls.
#
#  The reverse_string function accepts a string on the
#  stack, and returns on the stack a string which is the
#  reverse of it.

STRING

str1:	"\nTry reversing this"
str2:	"\nabcdefghijklmnopqrstuvwxyz"

CODE

main:
	ipush	0			# reserve space for return value
	icopy	str1, r0		# load first test
	spush	[r0]			# push parameter 1
	call	reverse_string		# call the function
	isub	1, sp, sp		# pop and discard parameter 1
	isub	1, sp, r0		# point to returned string
	sprint	[r0]			# print the returned string
	isub	1, sp, sp		# pop and discard the returned string

	ipush	0			# reserve space for return value
	icopy	str2, r0		# load first test
	spush	[r0]			# push parameter 1
	call	reverse_string		# call the function
	isub	1, sp, sp		# pop and discard parameter 1
	isub	1, sp, r0		# point to returned string
	sprint	[r0]			# print the returned string
	isub	1, sp, sp		# pop and discard the returned string

	halt

reverse_string:
	# reverse a string given two cells pushed on the stack,
	# the first [FP-4] is a place for the return value to go and
	# the second [FP-3] is the string to reverse (parameter 1)
	# remember: [FP-2] is the pc which was pushed by the call
	# and [FP-1] is the old FP which was pushed by the call

	# save some registers

	ipush	r0			# save r0, r1, r2, r3 onto the stack
	ipush	r1			# because we're going to change
	ipush	r2			# their values during this function
	ipush	r3			# and we need to restore them later

	# get parameter and return value addresses

	isub	4, fp, r0		# get address of return value
	isub	3, fp, r1		# get address of parameter 1

	# initialise local variables

	icopy	sp, r2			# address of local variable 1
	ipush	0			# space for local variable 1

	# initialise

	slen	[r1], r3		# how big is the string to reverse?
	snew	[r0]			# initialise return value to ""
loop:
	isub	1, r3			# subtract 1 from index
	icmp	0, r3			# compare zero and index
	bgt	end_reverse_string	# we're before the start of the string

	sindex	r3, [r1], [r2]		# get char at index r3 in source string
	sadd	[r2], [r0], [r0]	# add that char to the end of result

	bra	loop			# branch back to the loop

end_reverse_string:

	# remove local variables

	isub	1, sp, sp		# pop local variables

	# restore registers

	ipop	r3			# pop the registers we saved earlier
	ipop	r2			# back off the stack, so when we
	ipop	r1			# return from this function all
	ipop	r0			# those registers will be unchanged

	ret				# end of function reverse_string

